=== debian/changelog ===
ogre (14.3.1-1deepin1) unstable; urgency=medium

  * New upstream release

 -- Cryolitia <cryolitia@deepin.org>  Mon, 30 Jun 2025 14:34:22 +0800
