=== debian/control ===
Source: ogre
Priority: optional
Section: libs
Standards-Version: 4.5.1
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Manuel A. Fernandez Montecelo <mafm@debian.org>,
           Simon Schmeisser <s.schmeisser@gmx.net>
Homepage: https://ogre3d.org/
Vcs-Browser: https://salsa.debian.org/games-team/ogre
Vcs-Git: https://salsa.debian.org/games-team/ogre.git
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 12),
               cmake (>= 3.3.0),
               pkg-config,
               python3-dev,
               swig (>=3),
               libfreeimage-dev,
               libfreetype6-dev,
               libzzip-dev,
               zlib1g-dev,
               libz-dev,
               libglu1-mesa-dev | libglu-dev,
               libgl1-mesa-dev | libgl-dev,
               libgles2-mesa-dev | libgles2-dev,
               libxrandr-dev,
               libxxf86vm-dev,
               libxaw7-dev,
               libxt-dev,
               libpugixml-dev,
               libsdl2-dev,
               libimgui-dev,
               libstb-dev
Build-Depends-Indep: doxygen,
                     graphviz,
                     texinfo

Package: libogre-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libogre (= ${binary:Version})
Conflicts: libogre-1.12-dev, libogre-1.8-dev, libogre-1.9-dev
Suggests: ogre-doc
Description: 3D Object-Oriented Graphics Rendering Engine (development files)
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 This package contains the headers needed to develop with OGRE.

Package: libogre
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: 3D Object-Oriented Graphics Rendering Engine (libraries)
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 This package contains the library and plugins.

Package: ogre-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         libjs-jquery,
         libjs-mathjax
Description: 3D Object-Oriented Graphics Rendering Engine (documentation)
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 This package contains the documentation.

Package: ogre-tools
Section: devel
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Conflicts: ogre-tools, ogre-1.8-tools, ogre-1.9-tools
Description: 3D Object-Oriented Graphics Rendering Engine (tools)
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 This package contains tools used to convert from and to OGRE's native mesh
 format.
