=== debian/tests/control ===
Tests: test-tutorial
Depends: cmake, make, g++ | c++-compiler, libogre-dev
